/*
 * Copyright (c) 1992 Kent State University.
 * All rights reserved.  The Kent State University 
 * software License Agreement specifies the terms and conditions 
 * for redistribution.
 *
 *	@(#)non_signalf.c	1.1 (Kent State) 2/28/92
 *
 *	Author: Paul B. Ricks
 *
 *	The spirit of the Gnu Licensing Agreement Applies to this software and 
 *	Kent State University should be substituted where ever Gnu appears.
 *
 */


#ifndef lint
static char copyright[] =
"@(#) Copyright (c) 1992 Kent State University.\n\
 All rights reserved.\n";
#endif /* not lint */

#ifndef lint
static char sccsid[] = "@(#)non_signalf.c 1.1 (Kent State Univ.) 2/28/92";
#endif /* not lint */

/*

                            NO WARRANTY

   BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
REPAIR OR CORRECTION.

  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGES.

                     END OF TERMS AND CONDITIONS
*/


#include	"non_signalf.h"


int debug, daemonINDX;
char phoneline_status;
struct sockaddr_in xcmmd_addr;
struct sockaddr *xcmmd_ap = (struct sockaddr *)&xcmmd_addr;
int xcmmd_aplen = sizeof(*xcmmd_ap);

int	do_nonxstuff(argc, argv)
	int argc;
	char **argv;
{
	int tries;
	fd_set readmask;

	initEnvironment(argc, argv);

	relay_msg(0, 0);		  /* unblock parent to continue */
	answer_machine = 0;
	phoneline_status = ON_LINE;

	for (tries = 0;;errno = 0) {
	     FD_ZERO(&readmask);	
	     FD_SET(pto_child_sockt, &readmask);	/* for communicating with parent */
	     FD_SET(relay_sockt, &readmask);	/* for receiving calls from daemons */

	    if (select(relay_sockt + 1, &readmask, (fd_set *)0, (fd_set *)0, (struct timeval *)0) <= 0) {
		if (errno == EINTR)
		    continue; 
		if (++tries == MAX_TRIES) 
		    error_exit(SELECT_ERROR);
	    }
	    else if (FD_ISSET(pto_child_sockt, &readmask)) 
		processLRequest();
	    else if (FD_ISSET(relay_sockt, &readmask))
		    processDRequest();
	}
}

/*
	send file descriptor (socket) to parent
*/

int	send_file_d(fd)
	int fd;
{
	struct	iovec	iov[1];
	struct	msghdr	msg;

	iov[0].iov_len = 0;
	iov[0].iov_base = (char *)0;
	msg.msg_iov =iov;
	msg.msg_iovlen = 1;
	msg.msg_name = (caddr_t)0;
	msg.msg_accrights = (caddr_t)&fd;
	msg.msg_accrightslen = sizeof(fd);

	if (sendmsg(filed_con[1], &msg, 0) < 0)
	    return (relay_msg(SEND_FILE_ERROR, 0));
	else
	    relay_msg(TALK_LINE, 0);

	return (0);
}

/*
	take a call from the queue
*/

int	accept_call(call_id)
	int call_id;
{
	CTL_MSG *lmsg;
	CTL_RESPONSE resp;
	struct sockaddr addr;

	if (que_table[call_id].id == -1)
	    return (relay_msg(CANCELED, 0));

	lmsg = &que_table[call_id].call;
	que_table[call_id].id = -1;
	callwaiting--;

	resp.vers = lmsg->vers;
	resp.type = lmsg->type;
	resp.id_num = htonl(lmsg->id_num);
	resp.addr = lmsg->addr;
	resp.answer = SUCCESS;
	resp.xcomm = XCOMMFLAG;

	establish_connection(lmsg, &resp, &lmsg->ctl_addr);
	return (0);
}

/*
	delete a call from the queue
*/

int	do_deletion(msg)
	CTL_MSG *msg;
{

	register int i;

	for (i = 0; i < MAX_QUE_CALLS; i++)
	   if (que_table[i].id != -1)
	      if (!strcmp(que_table[i].call.l_name, msg->l_name)) {
		  relay_msg(HANGED_UP, que_table[i].id);
		  que_table[i].id = -1;
		  callwaiting--;
		  break;
	      }
	return (0);
}


/*
	turn on/off message
*/

int	toggle_phoneline()
{
	char lresp;
	char temp_status;
	int sockt, cc;
	register int i;
	CTL_RESPONSE resp;
	struct sockaddr_in addr;
	struct sockaddr fromaddr;

	if ((cc = get_sockt(SOCK_DGRAM, &sockt, &addr))) {
	    relay_msg(cc, 0);
	    return (0);
	}

	temp_status = phoneline_status == ON_LINE ? OFF_LINE:ON_LINE;	
	msg.type = PHONELINE;
	msg.answer = temp_status;

	msg_out(sockt, xcmmd_ap, xcmmd_aplen, (char *)&msg, sizeof(msg), &resp, &fromaddr, TRUE);
	lresp = resp.answer;
	if (activeFSites) {
	   for (i = 0; i < activeFSites; i++) {
		memcpy((char *)&xcmmd_addr.sin_addr.s_addr, (char *)&foreignSitesAddresses[i], sizeof(struct in_addr));
		msg_out(sockt, xcmmd_ap, xcmmd_aplen, (char *)&msg, sizeof(msg), &resp, &fromaddr, TRUE);
	   }
	   memcpy((char *)&xcmmd_addr.sin_addr.s_addr, (char *)&my_machine_addr, sizeof(struct in_addr));
	}

	if (lresp != SUCCESS)
	    relay_msg(DAEMON_RESPONSE, lresp);
	else
	    phoneline_status = temp_status;
	close(sockt);
	return (0);
}

/* 
	relay request to parent for respond
*/

int	relay_request(msg, mname)
	CTL_MSG *msg;
	char *mname;
{
	int cc;
	struct hostent *hp;
	struct sockaddr_in *ap;

	ap = (struct sockaddr_in *)&msg->ctl_addr;
	hp = gethostbyaddr(&ap->sin_addr, sizeof(struct in_addr), AF_INET);

	if (hp == (struct hostent *)0)
	    return (MACHINE_UNKNOWN);

	memcpy(mname, hp->h_name, hp->h_length);
	if (answer_machine)
	    return(0);

	(void)sprintf(pc_msg.line, "%-s~%-s~%-s", msg->l_name, hp->h_name, msg->r_tty);

	pc_msg.type = TALK_REQUEST;
	if (msg->xcomm)
	    pc_msg.id = XCOMMFLAG;
	else
	    pc_msg.id = 0;

	if (write(pto_child_sockt, (char *)&pc_msg, pc_msglen) != pc_msglen)
	    return (REFUSE_CALL);

	if ((cc = read(pto_child_sockt, (char *)&pc_msg, pc_msglen)) != pc_msglen)
	    return (REFUSE_CALL);

	return (pc_msg.type);
}

/*
	register our connection with the daemon
*/

int	register_connection(argc, argv)
	int argc;
	char **argv;
{
	char *sp;
	int i, fd;
	int sockt;
	struct hostent	*hp;
	CTL_RESPONSE response;
	struct sockaddr_in addr;
	struct sockaddr fromaddr;
	struct sockaddr *ap = (struct sockaddr *)&addr;
	char foreignSites[MAX_FOREIGN_SITES][MACHINE_NAMELEN];
	extern OLD_CALLS oldcalls[];

	get_myinfo();
	if (get_sockt(SOCK_DGRAM, &relay_sockt, &relay_addr)) {
	    fprintf(stderr, "Couldn't establish  relay connection.\n");
	    exit(0);
	}

	if (get_sockt(SOCK_DGRAM, &sockt, &addr)) {
	    fprintf(stderr, "Couldn't establish  relay connection.\n");
	    close(relay_sockt);
	    exit(0);
	}

        memset((char *)&msg, '\0', sizeof(msg));
	strncpy(msg.l_name, my_name, NAME_SIZE);
	msg.vers = TALK_VERSION;
	msg.type = REGISTER;
	msg.xcomm = XCOMMFLAG;
	msg.answer = ON_LINE;
	msg.pid = childpid;
	msg.ctl_addr = msg.addr = *(struct sockaddr *)&relay_addr;

	parseArgs(argc, argv, foreignSites);

	memset((char *)xcmmd_ap, '\0', xcmmd_aplen);
	xcmmd_addr.sin_family = AF_INET;

#ifdef XCOMM_NO_SU
	    xcmmd_addr.sin_port = htons(XCOMM_DPORT);
#else
	    xcmmd_addr.sin_port = htons(daemon_port);
#endif

	for (activeFSites = i = 0; i < foreignSCount; i++) {
	     if ((hp = gethostbyname(foreignSites[i])) == NULL) {
		  fprintf(stderr, "Unable to obtain address of site: <%-s>.\n", foreignSites[i]);
		  continue;
	     }
	     if (!memcmp((char *)&my_machine_addr, (char *)hp->h_addr, sizeof(my_machine_addr)))
		 continue;
	     memcpy((char *)&xcmmd_addr.sin_addr.s_addr, (char *)hp->h_addr,  hp->h_length);
	     msg_out(sockt, xcmmd_ap, xcmmd_aplen, (char *)&msg, sizeof(msg), &response, &fromaddr, TRUE);
	     if (response.answer == SUCCESS)
	         memcpy((char *)&foreignSitesAddresses[activeFSites++], (char *)hp->h_addr, hp->h_length);
	     else if (response.answer == PERMISSION_DENIED)
		 fprintf(stderr, "Not allowed to register at >%-s<\n", foreignSites[i]);
	     else
		 fprintf(stderr, "Couldn't reach daemon at <%-s>.\n", foreignSites[i]);
	}

	memcpy((char *)&xcmmd_addr.sin_addr.s_addr, (char *)&my_machine_addr, sizeof(struct in_addr));
	msg_out(sockt, xcmmd_ap, xcmmd_aplen, (char *)&msg, sizeof(msg), &response, &fromaddr, TRUE);

	if (response.answer != SUCCESS) {
	    fprintf(stderr, "Couldn't get hold of talk daemon.\n");
	    error_exit(0);
	}

	close(sockt);
	for (i = 0; i < MAX_QUE_CALLS; i++)
	     que_table[i].id = -1;

	for (i = 0; i < MAX_OLD_CALLS; i++)
	     oldcalls[i].port = -1;

	return (0);
}

/*
	get my machine address and etc.
*/

int	get_myinfo()
{
	char *q;
	struct	servent	*sp;
	struct	hostent	*hp;

	extern char *getlogin();
	extern char MESSAGE_IN[], MESSAGE_OUT[];

	if ((my_name = getlogin()) == NULL) {
	    fprintf(stderr, "Man, get outta here, you don't exist !!!!\n");
	    exit(0);
	}

	gethostname(my_machine_name, sizeof(my_machine_name));
	if ((hp = gethostbyname(my_machine_name)) == NULL) {
	    fprintf(stderr, "Host machine doesn't exist. Can't deal with a ghost machine !!!\n");
	    exit(0);
	}

	if ((sp = getservbyname("talk", "udp")) == NULL) {
	    fprintf(stderr, "This machine doesn't support [x]comm.\n");
	    exit(0);
	}

	daemon_port = sp->s_port;
	memcpy((char *)&my_machine_addr, (char *)hp->h_addr, hp->h_length);

	return (0);
}

/*
	function to get a socket and bind a name to it
*/
int	get_sockt(sockt_type, sockt, sockt_rec)
	int	sockt_type;
	int	*sockt;
	struct	sockaddr_in *sockt_rec;
{ 
	int	length;

	length = sizeof(*sockt_rec);

	memset((char *)sockt_rec, '\0', length);
	sockt_rec->sin_port = 0;
	sockt_rec->sin_family = AF_INET;
/*
	sockt_rec->sin_addr.s_addr = htonl(INADDR_ANY);
*/

	sockt_rec->sin_addr = my_machine_addr;

	if ((*sockt = socket(AF_INET, sockt_type, 0)) <= 0)
	    return (GETTIN_SOCKET_ERROR);
	if (bind(*sockt, (struct sockaddr *)sockt_rec, length) != 0) 
	    return (BINDIN_SOCKET_ERROR);
	if (getsockname(*sockt, (struct sockaddr *)sockt_rec, &length) != 0) 
	    return (BINDIN_SOCKET_ERROR);
	return (0);
}

/*
	get his information 
*/
int	get_hisinfo(str, his_machine_addr)
	char	str[];
	struct in_addr *his_machine_addr;
{
	register char *sp;
	struct hostent *hp;
	char	*his_machine_name, *his_name, *his_tty;

	extern char  *strpbrk();

	local_call = FALSE;

	his_name = strtok(str, "@:!.");
	sp = strtok((char *)0, " ");

	if (sp) {
	    his_machine_name = sp;
	    if ((sp = strtok((char *)0, " ")) != (char *)0)
		his_tty = sp;
	    else
		his_tty = "";
	}
	else {
	    his_machine_name = my_machine_name;
	    his_tty = "";
	}

	(void)sprintf(pc_msg.line, "%-s~%-s~%-s", his_name, his_machine_name, his_tty);
	relay_msg(HIS_INFORMATION, 0);

	if (!strcmp(his_machine_name, my_machine_name))
	    memcpy((char *)his_machine_addr, (char *)&xcmmd_addr.sin_addr.s_addr, sizeof(struct in_addr));
	else if ((hp = gethostbyname(his_machine_name)) == (struct hostent *)0)
	    return (relay_msg(MACHINE_UNKNOWN, 0));
	else
	    memcpy((char *)his_machine_addr, (char *)hp->h_addr, hp->h_length);
	if (!strcmp(his_name, my_name) && !memcmp((char *)&my_machine_addr, (char *)&his_machine_addr, hp->h_length)) 
	    return (relay_msg(NUT_HOUSE, 0));

	msg.id_num = htonl(0);
	memset(msg.r_name, '\0', NAME_SIZE);
	memcpy(msg.r_name, his_name, NAME_SIZE - 1);
	memset(msg.r_tty, '\0', TTY_SIZE);
	memcpy(msg.r_tty, his_tty, TTY_SIZE - 1);

	return 0;
}

/*
	something went wrong perhaps, so just quit
*/

int	error_exit(ecode)
	char ecode;
{
	register int i;
	CTL_RESPONSE resp;
	struct sockaddr fromaddr;

	extern int filed_con[];

	msg.type = DE_REGISTER;
	memset(msg.r_name, '\0', NAME_SIZE);
	memcpy(msg.r_name, my_name, NAME_SIZE - 1);
	memcpy((char *)&xcmmd_addr.sin_addr.s_addr, (char *)&my_machine_addr, sizeof(struct in_addr));
	msg_out(relay_sockt, xcmmd_ap, sizeof(*xcmmd_ap), (char *)&msg, sizeof(msg), &resp, &fromaddr, FALSE);
	for (i = 0; i < activeFSites; i++) {
	     memcpy((char *)&xcmmd_addr.sin_addr.s_addr, (char *)&foreignSitesAddresses[i], sizeof(struct in_addr));
	     msg_out(relay_sockt, xcmmd_ap, sizeof(*xcmmd_ap), (char *)&msg, sizeof(msg), &resp, &fromaddr, FALSE);
	}
	close(0); close(1); close(filed_con[1]);
	exit(0);
}

int	isfreshRequest(m)
	register CTL_MSG *m;
{
	register int i;
	static char ccounter = 0;
	register struct sockaddr_in *ap;

	ap = (struct sockaddr_in *)&m->ctl_addr;
	for (i = 0; i < MAX_OLD_CALLS; i++)
	     if (oldcalls[i].port < 0)
		 break;
	     else if (ap->sin_port == oldcalls[i].port && !strcmp(m->l_name, oldcalls[i].u_name) &&
		      !strncmp((char *)&ap->sin_addr, (char *)&oldcalls[i].address, sizeof(struct in_addr)))
		      return (0);

	strcpy(oldcalls[ccounter].u_name, m->l_name);
	oldcalls[ccounter].port = ap->sin_port;
	oldcalls[ccounter++].address = ap->sin_addr;
	ccounter %= MAX_OLD_CALLS;

	return (1);	/* yes -- this is a fresh request */
}

int	parseArgs(argc, argv, foreignSites)
	int argc;
	char **argv;
	char foreignSites[][MACHINE_NAMELEN]; 
{
	register int i;

	foreignSCount = debug = 0;
	for (i = 1; i < argc; i++) {
	    if (argv[i][0] == '-') {
	       if ((i+1) < argc && foreignSCount < MAX_FOREIGN_SITES &&
		   (!strcmp(argv[i], "-fsite") || !strcmp(argv[i], "-fs"))) {
		   strcpy(foreignSites[foreignSCount++], argv[i+1]);
		   memcpy(argv[i], "ign", 3);
		   i++;
	       }
	       else if (!strcmp(argv[i], "-debug")) {
		   debug = 1;
		   memcpy(argv[i], "ign", 3);
	       }

	    }
	}
}
