/*
 * Copyright (c) 1992 Kent State University.
 * All rights reserved.  The Kent State University 
 * software License Agreement specifies the terms and conditions 
 * for redistribution.
 *
 *	@(#)xcmain.c	1.1 (Kent State) 2/28/92
 *
 *	Author: Paul B. Ricks
 *
 *	The spirit of the Gnu Licensing Agreement Applies to this software and 
 *	Kent State University should be substituted where ever Gnu appears.
 *
 */


#ifndef lint
static char copyright[] =
"@(#) Copyright (c) 1992 Kent State University.\n\
 All rights reserved.\n";
#endif /* not lint */

#ifndef lint
static char sccsid[] = "@(#)xcmain.c 1.1 (Kent State Univ.) 2/28/92";
#endif /* not lint */

/*

                            NO WARRANTY

   BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
REPAIR OR CORRECTION.

  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGES.

                     END OF TERMS AND CONDITIONS
*/

#include  "xcmain.h"

void	sigcld_handler();
void	msigterm_handler();
char MESSAGE_IN[MAX_MSGBUF], MESSAGE_OUT[MAX_MSGBUF];

main(argc, argv)
int	argc;
char	**argv;
{

    	char	*term = (char *) getenv("TERM");

    	if (strcmp(term, "xterm")) {
            fprintf(stderr, "Not an X Display, use [ talk ] instead.\n");
	    _exit(0);
	}

	if (socketpair(AF_UNIX, SOCK_STREAM, 0, fds) < 0) {
	    fprintf(stderr, "Cannot create socket for communication");
	    _exit(0);
	}

	if (socketpair(AF_UNIX, SOCK_STREAM, 0, filed_con) < 0) {
	    fprintf(stderr, "Cannot create socket for communication");
	    _exit(0);
	}

	{
	    char *q;

	    q = getenv("HOME");
	    sprintf(MESSAGE_IN, "%-s/.xcomm_msgin", q);
	    sprintf(MESSAGE_OUT, "%-s/.xcomm_msgout", q);
	}
	parentpid = getpid();
	if ((childpid = fork()) < 0) {
	    fprintf(stderr, "Cannot create work horse (child process)");
	    _exit(0);
	}
	else if (childpid == 0)
	    do_nonxstuff(argc, argv);

	signal(SIGCLD, (void (*)())sigcld_handler);
	signal(SIGTERM, (void (*)())msigterm_handler);
	signal(SIGINT, (void (*)())msigterm_handler);

	do_xstuff(argc, argv);
}


int	do_xstuff(argc, argv)
	int	argc;
	char	**argv;
{
	fd_set	readmask;
	extern LOCAL_MSG pc_msg;
	extern void do_xcommunicate();

	close(fds[1]);
	close(filed_con[1]);

	FD_ZERO(&readmask);
	FD_SET(fds[0], &readmask);

	select(fds[0] + 1, &readmask, (fd_set *)0, (fd_set *)0, (struct timeval *)0);
	read(fds[0], (char *)&pc_msg, sizeof(pc_msg));

	do_xcommunicate(argc, argv);
	fprintf(stderr, "\07\07\07\07Shouldn't have come down here. !!!\n");
	kill(childpid, SIGTERM);
	exit(0);
}

int	EditHisinput(ch, his_edchars, bline, sp)
	char ch;
	char his_edchars[];
	char bline[], **sp;
{
	char *sp3, *sp2;

	if (bline == *sp) return (0);

	if (ch == his_edchars[0]) {
	    (*sp)--;
	}
	else if (ch == his_edchars[2]) {
	     **sp = '\0';
	     sp2 = strrchr(bline, '\t');
	     sp3 = strrchr(bline, ' ');
	     if (sp3 > sp2)
		 sp2 = sp3;
	     if ((sp3 = strrchr(bline, '\n')) == (char *)0)
		 sp3 = bline;
	     if (sp2 != (char *)0) {
		 if (sp3  != (char *)0 && sp2 < sp3)
		     *sp = sp3 + 1;
		 else
		     *sp = sp2;
	     }
	     else
		 *sp = bline;
	 }
	 else if (ch == his_edchars[1]) {
	     **sp = '\0';
	     if ((sp2 = strrchr(bline, '\n')) != NULL)
		 *sp = sp2 + 1;
	     else *sp = bline;
	 }
	 else
	     **sp++ = ch;
}


void	sigcld_handler()
{
	exit(0);
}

void	msigterm_handler()
{
	int status;

	kill(childpid, SIGTERM);
	wait(&status);
	exit(0);
}
