/*
 * Copyright (c) 1992 Kent State University.
 * All rights reserved.  The Kent State University 
 * software License Agreement specifies the terms and conditions 
 * for redistribution.
 *
 *	@(#)xcommon.h	1.1 (Kent State) 2/28/92
 *
 *	Author: Paul B. Ricks
 *
 *	The spirit of the Gnu Licensing Agreement Applies to this software and 
 *	Kent State University should be substituted where ever Gnu appears.
 *

#ifndef lint
static char copyright[] =
"@(#) Copyright (c) 1992 Kent State University.\n\
 All rights reserved.\n";
#endif 

#ifndef lint
static char sccsid[] = "@(#)xcommon.c 1.1 (Kent State Univ.) 2/28/92";
#endif


                            NO WARRANTY

   BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
REPAIR OR CORRECTION.

  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGES.

                     END OF TERMS AND CONDITIONS
*/

#include	<stdio.h>
#include	<signal.h>
#include	<string.h>
#include	<sys/wait.h>
#include	<sys/fcntl.h>
#include	<sys/file.h>
#include        <X11/cursorfont.h>
#include        <X11/keysym.h>
#include	<X11/Xlib.h>
#include        <X11/Intrinsic.h>
#include        <X11/StringDefs.h>
#include        <X11/Xatom.h>
#include        <X11/Xaw/Cardinals.h>
#include        <X11/Shell.h>
#include        <X11/Xaw/Text.h>
#include        <X11/Xaw/AsciiText.h>
#include        <X11/Xaw/Box.h>
#include        <X11/Xaw/Form.h>
#include        <X11/Xaw/Label.h>
#include        <X11/Xaw/Dialog.h>
#include        <X11/Xaw/Toggle.h>
#include        <X11/Xaw/Command.h>
#include        <X11/Xaw/SmeLine.h>
#include        <X11/Xaw/SmeBSB.h>
#include        <X11/Xaw/TextSrc.h>
#include        <X11/Xaw/SimpleMenu.h>
#include        <X11/Xaw/MenuButton.h>
#include        <X11/Xaw/Scrollbar.h>
#include        <X11/Xaw/List.h>
#include        <X11/Xaw/Viewport.h>

#include	"talkd.h"
#include	"xcomm.h"

#define	Little_BufSize	10
#define	Max_Panels	10
#define	MAX_RELAYERRORS	10
#define	LittleBuf	30
#define	MAX_BUFSIZE	80


#define ERROR_INTERVAL	5999
#define CALL_INTERVAL	6999
#define VSHORT_REPEAT	4
#define VVSHORT_REPEAT	2
#define SHORT_REPEAT	8
#define MEDIUM_REPEAT	16
#define LONG_REPEAT	3365
#define INVITATION_INTVAL 59000
#define INFINITE_RING	3655

#define BELL_TONE0	10
#define BELL_TONE1	20
#define BELL_TONE2	40
#define BELL_TONE3	50
#define BELL_TONE4	80
#define BELL_TONE5	100

#define Frequency_00	350
#define Frequency_01	475
#define Frequency_02	550
#define Frequency_03	700
#define Frequency_04	950
#define Frequency_05	1040
#define Frequency_06	1210
#define Frequency_07	1300
#define Frequency_08	1550

#define FQ0_INDX 0
#define FQ1_INDX 1
#define FQ2_INDX 2
#define FQ3_INDX 3
#define FQ4_INDX 4
#define FQ5_INDX 5
#define FQ6_INDX 6
#define FQ7_INDX 7
#define FQ8_INDX 8

#define ON	1
#define OFF	0

typedef struct {		/* struct containing information for calls on hold */
	int id;			/* id provided by child */
	char name[NAME_SIZE];	/* user name */
	char address[MAX_MSGBUF]; /* site name of caller */
} onholdRec; 

typedef struct {		/* struct passed to the message repeater (status line) */
	Bool active;
	int len;		/* length of the string */
	char idx;		/* index into the frequency array */
	char repeatc;		/* number of times to repeat (flash) messages */
	char *estring;		/* text to display in status line */
	int  ringcount;		/* number of times to ring the bell */
	XtIntervalId id;	/* timeout id */
	char bellduration;	/* duration of bell (bell tone) */
} errorRec;
